const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class GuaranteesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const guarantees = await db.guarantees.create(
      {
        id: data.id || undefined,

        method: data.method || null,
        amount: data.amount || null,
        status: data.status || null,
        proof_url: data.proof_url || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await guarantees.setTenant(data.tenant || null, {
      transaction,
    });

    await guarantees.setReservation(data.reservation || null, {
      transaction,
    });

    await guarantees.setAgences(data.agences || null, {
      transaction,
    });

    return guarantees;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const guaranteesData = data.map((item, index) => ({
      id: item.id || undefined,

      method: item.method || null,
      amount: item.amount || null,
      status: item.status || null,
      proof_url: item.proof_url || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const guarantees = await db.guarantees.bulkCreate(guaranteesData, {
      transaction,
    });

    // For each item created, replace relation files

    return guarantees;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const guarantees = await db.guarantees.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.method !== undefined) updatePayload.method = data.method;

    if (data.amount !== undefined) updatePayload.amount = data.amount;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.proof_url !== undefined) updatePayload.proof_url = data.proof_url;

    updatePayload.updatedById = currentUser.id;

    await guarantees.update(updatePayload, { transaction });

    if (data.tenant !== undefined) {
      await guarantees.setTenant(
        data.tenant,

        { transaction },
      );
    }

    if (data.reservation !== undefined) {
      await guarantees.setReservation(
        data.reservation,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await guarantees.setAgences(
        data.agences,

        { transaction },
      );
    }

    return guarantees;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const guarantees = await db.guarantees.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of guarantees) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of guarantees) {
        await record.destroy({ transaction });
      }
    });

    return guarantees;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const guarantees = await db.guarantees.findByPk(id, options);

    await guarantees.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await guarantees.destroy({
      transaction,
    });

    return guarantees;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const guarantees = await db.guarantees.findOne({ where }, { transaction });

    if (!guarantees) {
      return guarantees;
    }

    const output = guarantees.get({ plain: true });

    output.tenant = await guarantees.getTenant({
      transaction,
    });

    output.reservation = await guarantees.getReservation({
      transaction,
    });

    output.agences = await guarantees.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.tenants,
        as: 'tenant',

        where: filter.tenant
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.tenant
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.tenant
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.reservations,
        as: 'reservation',

        where: filter.reservation
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.reservation
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  ref: {
                    [Op.or]: filter.reservation
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.proof_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('guarantees', 'proof_url', filter.proof_url),
        };
      }

      if (filter.amountRange) {
        const [start, end] = filter.amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.method) {
        where = {
          ...where,
          method: filter.method,
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.guarantees.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('guarantees', 'method', query),
        ],
      };
    }

    const records = await db.guarantees.findAll({
      attributes: ['id', 'method'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['method', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.method,
    }));
  }
};
